import { ESSceneObject, NativeNumber16Type, PositionEditing } from 'vtxf-xe2/dist-node/xe2-base-objects';
import { Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from 'vtxf-xe2/dist-node/xe2-base-utils';
import { SceneObjectKey, SceneObjectWithId } from 'vtxf-xe2/dist-node/xe2-utils';
import * as Cesium from 'cesium';
import { Czm3DTilesCustomShaderInstanceClassType } from './Czm3DTiles';
import { CzmPolylinesPrimitive } from './CzmPolylinesPrimitive';
export declare class CzmFlattenedPlane extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        enabled: boolean;
        showHelper: boolean;
        positionEditing: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        modelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type>;
        reverse: boolean;
        discard: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        topColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        bottomColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        edgeColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        edgeWidth: number;
        minSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        maxSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        /**
         * @deprecated 该属性已弃用，请使用Czm3dTiles的czmFlattenedPlaneId属性！
        */
        sceneObjectIds: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[]>;
        czmTextureId: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    static defaults: {
        position: [number, number, number];
        viewerTagsEnums: [string, string][];
    };
    private _computedCustomShader;
    get computedCustomShader(): Czm3DTilesCustomShaderInstanceClassType | undefined;
    set computedCustomShader(value: Czm3DTilesCustomShaderInstanceClassType | undefined);
    get computedCustomShaderChanged(): Listener<[Czm3DTilesCustomShaderInstanceClassType | undefined, Czm3DTilesCustomShaderInstanceClassType | undefined]>;
    private _sPositionEditing;
    get sPositionEditing(): PositionEditing;
    private _polylines;
    get polylines(): CzmPolylinesPrimitive;
    private _polylinesInit;
    private _finalMatrix;
    get finalMatrix(): Cesium.Matrix4 | undefined;
    set finalMatrix(value: Cesium.Matrix4 | undefined);
    get finalMatrixChanged(): Listener<[Cesium.Matrix4 | undefined, Cesium.Matrix4 | undefined]>;
    private _czmTextureWithId;
    get czmTextureWithId(): SceneObjectWithId<import("vtxf-xe2/dist-node/xe2-base-objects").SceneObject>;
    private _czmTextureWithIdInit;
    constructor(id?: SceneObjectKey);
    getProperties(language?: string): import("vtxf-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmFlattenedPlane {
    const createDefaultProps: () => {
        enabled: boolean;
        showHelper: boolean;
        positionEditing: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        modelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type>;
        reverse: boolean;
        discard: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        topColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        bottomColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        edgeColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        edgeWidth: number;
        minSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        maxSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        /**
         * @deprecated 该属性已弃用，请使用Czm3dTiles的czmFlattenedPlaneId属性！
        */
        sceneObjectIds: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[]>;
        czmTextureId: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
}
export interface CzmFlattenedPlane extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmFlattenedPlane.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmFlattenedPlane.createDefaultProps> & {
    type: string;
}>;
export {};
